package Bench;

import java.util.Random;

import CTL.*;
import CTL.Types.*;
import javaSys.*;

/** Latency benchmark client */
public class Latency
{
	private final static int calls = 100;
	
	public static void main (String[] args)
	{
		Location loc = new Location("pare18:2789 dmn");
		CTL.Process proc = new CTL.Process(loc);
		MatheCI.use(proc);
		MatheCI mat = new MatheCI();
		
		Random r = new Random();
		long total = 0;
		int a, b, c;
		
		for (int i=0;i<calls;i++)
		{
			Timer t = new Timer();
			a = r.nextInt(10000);
			b = r.nextInt(10000);
			c = mat.add(a, b);
			total += t.stop();
			System.out.println(a+" + "+b+" = "+c+"\tcalculated in "+
				t+" seconds.");
		}

		System.out.println("\nAverage time per call: "+
			Timer.timestr(total/calls)+" seconds.");
	}
}
