package CTL;

import ReflWrap.*;

import java.util.*;

public class AnyObjIdentMap
{
	private HashMap<String,Class> StrToClass = new HashMap<String,Class>();
	private HashMap<Class,String> ClassToStr = new HashMap<Class,String>();

	public void put (String ident, Class c)
	{
		StrToClass.put(ident, c);
		ClassToStr.put(c, ident);
	}

	public String get (Class c)
	{
		String ret = ClassToStr.get(c);
		if (ret == null)
			ret = new ClassInfo(c).fqcncs();
		return ret;
	}

	public Class get (String ident) throws ClassNotFoundException
	{
		Class ret = StrToClass.get(ident);
		if (ret == null)
		{
			ident = ClassInfo.cncs2java(ident);
			ret = Refl.getClass(ident);
			if (ret == null)
				ret = Class.forName(ident);
		}
		return ret;
	}

	public String toString ()
	{
		StringBuffer ret = new StringBuffer();
		for (Class c : ClassToStr.keySet())
			ret.append(c.getName()+" -> "+ClassToStr.get(c));
		return ret.toString();
	}
}
