package CTL.Serialize;

import CTL.Types.*;

import java.io.*;
import java.lang.reflect.*;

/**
 * The Writable interface is an alternative method of serializing data via
 * OIStream/OOStream, where the reading side must know exactly which type
 * it wants to read. This is useful to read/write containers to a stream, 
 * like a header with a known structure. By using the Writable interface,
 * information on how to read/write data can be encapsulated inside the
 * data structures itself.
 */
public interface Writable 
{
	void read (SerialIn in) throws IOException, ClassNotFoundException, 
		InstantiationException, IllegalAccessException, InvocationTargetException;
	void write (SerialOut out) throws IOException, IllegalAccessException,
		InvocationTargetException, CTLException;
}
