package CTL.Streams;

import CTL.RUtil;
import CTL.Types.CTLException;

import java.io.*;
import java.lang.reflect.*;

/** Class which holds a number of function arguments in memory for later 
 * 	writing.
 */
public class IStream2 extends OOStream
{
	private ByteArrayOutputStream bout;

	public IStream2 () throws IOException, CTLException
	{
		this(new ByteArrayOutputStream());
	}
	
	public IStream2 (ByteArrayOutputStream bout) throws IOException, 
		CTLException
	{
		super(bout);
		this.bout = bout;
	}

	private byte[] getBytes ()
	{
		return bout.toByteArray();
	}

	public void writeToStream (OOStream str, boolean dummy) throws IOException,
		IllegalAccessException, InvocationTargetException
	{
		str.writeBytes(new String(getBytes()));
	}

	public int streamSize ()
	{
		return getBytes().length;
	}

	public void write (int val) throws IOException
	{
		// DataOutputStream defines a weird write(int) method
		try
		{
			write(new Integer(val));
		} 
		catch (IllegalAccessException e0) {}
		catch (InvocationTargetException e1) {}
	}
	
	public <T extends Object> void write (T val) throws IOException,
		IllegalAccessException, InvocationTargetException
	{
		if (val == null) 
			return;
		
		Object[] args = new Object[1];
		args[0] = val;
		RUtil.serialwr.invoke(this, args);
	}

	public String toString ()
	{
		Tools.HexDumper dump = new Tools.HexDumper(getBytes());
		return dump.convert();
	}
}
