package CTL.Streams;

import CTL.Types.*;

import java.io.*;
import java.lang.reflect.*;

/** Interface for CTL output streams */
public interface OutStream extends DataOutput
{
	public void writeString (String data) throws IOException;
	public void writeWString (String data) throws IOException;

	public <T extends Object> void writeArray (T data) throws 
		IOException, IllegalAccessException, InvocationTargetException;
	public <T extends Object> void __writeArray (T data) throws 
		IOException, IllegalAccessException, InvocationTargetException;
	
	public void writeObject (Object data) throws IOException, 
		IllegalAccessException, InvocationTargetException, CTLException;
	public void serialWrite (Object data) throws IOException, 
		IllegalAccessException, InvocationTargetException, CTLException;
}
