package CodeGen;

import CTL.Annotate.*;
import ReflWrap.*;

import java.lang.reflect.*;
import java.util.*;

public class Konstruktor
{
	@SuppressWarnings("unused")
	private Constructor con;
	private ConstructInfo cInfo;
	private String params;
	private int len;

	public Konstruktor (Constructor con)
	{
		this.con = con;
		cInfo = new ConstructInfo(con);
		params = cInfo.paramsToString();
		len = cInfo.params().length;
	}

	public String params ()
	{
		return params;
	}

	public int len ()
	{
		return len;
	}

	public static Konstruktor[] fetchAll (ClassInfo cinfo)
	{
		LinkedList<Konstruktor> list = new LinkedList<Konstruktor>();
		
		for (Constructor con : cinfo.constructors())
		{
			if (con.isAnnotationPresent(cdont.class))
				 continue;
			list.add(new Konstruktor(con));
		}

		Konstruktor[] ret = new Konstruktor[list.size()];
		for (int i=0;i<ret.length;i++)
			ret[i] = list.get(i);

		return ret;
	}
}
