package CodeGen;

import CTL.Annotate.*;
import ReflWrap.*;

import java.lang.reflect.*;
import java.util.*;

public class Methode
{
	private ClassInfo cinfo;
	private Method meth;
	private MethodInfo minfo;
	private boolean _const = false;

	public Methode (ClassInfo cinfo, Method meth)
	{
		this.cinfo = cinfo;
		this.meth = meth;
		minfo = new MethodInfo(meth);
		if (cinfo != null)
			_const = cinfo.isAnot(const_.class);
	}

	public boolean _const ()
	{
		return _const;
	}

	public boolean dont ()
	{
		return meth.isAnnotationPresent(dont.class);
	}

	public int len ()
	{
		return minfo.params().length;
	}

	public boolean here ()
	{
		return minfo._class()==cinfo._class();
	}

	public boolean isVoid ()
	{
		return minfo.returns().name().equals("void");
	}

	public boolean isStatic ()
	{
		return minfo.isStatic();
	}

	public String head (boolean isrResult)
	{
		if (isrResult)
			return minfo.modifiersToString()+
				(isVoid() ? "void " : "rResult ")+
				minfo.name()+"_rr ("+minfo.paramsToString();
		return minfo.toString();			
	}

	public String name ()
	{
		return minfo.name();
	}

	public String modifiers ()
	{
		return minfo.modifiersToString();
	}

	public String params ()
	{
		return minfo.paramsToString();
	}

	public String returns ()
	{
		return minfo.returns().name();
	}

	public String returnsT ()
	{
		return minfo.returnsT();
	}

	public MethodInfo minfo ()
	{
		return minfo;
	}

	public static Methode[] fetchAll (ClassInfo cinfo)
	{
		LinkedList<Methode> list = new LinkedList<Methode>();
		
		for (Method m : cinfo.methods())
		{
			if (m == null)
				list.add(null);
			else
				list.add(new Methode(cinfo, m));
		}

		Methode[] ret = new Methode[list.size()];
		for (int i=0;i<ret.length;i++)
			ret[i] = list.get(i);
		
		return ret;
	}
}
