package Impl.Types;

import CTL.Serialize.*;

import java.io.*;

/** Test data structure class */
public class DoubleDash implements Writable
{
	static
	{
		/* 
		 * This is how you specify custom AnyObj identifier strings for
		 * compatibility with C++. For Java-only projects, you can simply
		 * do nothing and it will work automagically.
		 */
		CTL.Env.AnyObjIdent.put("ctl::foobar", DoubleDash.class);
	}
	
	private double d;
	private float f;

	public DoubleDash ()
	{
		d = 0.0;
		f = (float)0.0;
	}

	public DoubleDash (double d, float f)
	{
		this.d = d;
		this.f = f;
	}

	public double getDouble ()
	{
		return d;
	}

	public float getFloat()
	{
		return f;
	}

	public void setDouble (double d)
	{
		this.d = d;
	}

	public void setFloat (float f)
	{
		this.f = f;
	}

	public boolean equals (DoubleDash d)
	{
		if (toString().equals(d.toString()))
			return true;
		return false;
	}

	public String toString ()
	{
		return "Double value: "+d+"; Float value: "+f;
	}
	
	public void read (SerialIn in) throws IOException, ClassNotFoundException
	{
		d = in.readDouble();
		f = in.readFloat();
	}
	
	public void write (SerialOut out) throws IOException
	{
		out.writeDouble(d);
		out.writeFloat(f);
	}
}
