package NCLib;

import java.io.*;
import java.util.*;
import java.util.regex.*;

public class Template
{
	private String input;
	private HashMap<String,String> map;

	public Template (String fname)
	{
		map = new HashMap<String,String>();
		input = Files.readAll(fname);
		Pattern p = Pattern.compile("%.*\\%");
		Matcher m = p.matcher(input);
		while (m.find())
		{
			String tmp = m.group();
			tmp = tmp.substring(1, tmp.length()-1);
			map.put(tmp, "");
		}
	}

	public Set<String> fields ()
	{
		return map.keySet();
	}

	public boolean set (String key, String value)
	{
		if (!map.containsKey(key))
			return false;
		map.put(key, value);
		return true;
	}

	public String toString ()
	{
		String ret = input;
		for (String key : fields())
		{
			String value = map.get(key);
			Pattern p = Pattern.compile("%"+key+"%");
			Matcher m = p.matcher(ret);
			ret = m.replaceAll(value);
		}
		return ret;
	}

	public void write (String fname)
	{
		Files.writeAll(fname, toString());
	}

	public static void main (String[] args)
	{
		Template tmpl = new Template("data/test.tmpl");
		tmpl.set("name", "Frankie");
		tmpl.set("name2", "Ocle");
		System.out.print(tmpl);
	}
}
